

# koronapos-labelprint-webservice



## Usage

### Supported Field Types

#### productNumber

#### saleRecognitionCode

Depends how the articles was booked

#### productDescription

#### saleDescription

#### productPrice
Printed with isoCode. If it is CHF price is formatted to CHF else german euro.

#### expirationDate
    ```
		if (sale.product.hasOwnProperty('texts') && sale.product.texts.hasOwnProperty('warrantyText')) {
			var receiptDate = new Moment(sale.bookingTime, 'YYYY-MM-DDTHH:mm:ss.SSSZZ');
			receiptDate.hours(sale.product.texts.warrantyText);
			return receiptDate.format(textFieldConfig.dateFormat);
		}
		return '';
    ```
	

#### text
Default Text aus Json Konfiguration



#### actualDate
jetziges Datum
##### reverseText
Datum invertieren
##### dateFormat
Datumformat
	

#### descriptionText
		sale.product.texts.description;
		
#### receiptText
sale.product.texts.receiptText

#### orderText
sale.product.texts.orderText

#### recipeText
sale.product.texts.recipe
#### ingredientsText
sale.product.texts.ingredients
#### allergenText
sale.product.texts.allergens

#### additiveText
return sale.product.texts.additives;
#### nutritionText
sale.product.texts.nutritionalValue;
		
#### careText
sale.product.texts.careInstructions;
#### instructionText
sale.product.texts.manual
#### certificateText
sale.product.texts.certificate
#### warrantyText
sale.product.texts.warrantyText


## Developing



### Tools

## old wiki

= KORONA.Labelprint =
Labelprint ist ein in Node.js geschriebenes Tool zur Erzeugung von grafischen Etiketten via der KORONA.pos Kasse. Anhand eines konfigurierbaren Layouts kann das Etikett mittels eines auf Millimeter geeichten Koordinatensystems individualisiert werden.
==Wo finde ich mein Labelprint!?==
Im gewünschten Ordner mit persönlichem Domainaccount ausführen:
git clone http://srvgit.cag.combase.de:8080/korona/pos/labelprint

aktuell: https://gitlab.combase.de/combase/korona/pos/plugins/KORONA.pos-labelprint

==Changelog==
1.0.0 - init
1.1.0 - Neuer Aufruf für das akkumulieren von Preisen
==Installation==
* Labelprint auf dem Kundensystem aufsetzen
** [https://nodejs.org/ Node.js] Runtime installieren
** Bei Windows-Installationen ein PDF Anzeigeprogramm installieren (vorzugsweise den Adobe Reader)
** Labelprint-Ordner in gewünschten Pfad auschecken und falls nicht vorhanden, im Verzeichnis public das Unterverzeichnis spool erstellen
** labelprint.properties pflegen
*** Unter Windows muss ein Shell-Kommando zum drucken der PDF hinterlegt werden (Bsp.: printCommandShell="C:\\Program Files (x86)\\Adobe\\Acrobat Reader DC\\Reader\\AcroRd32.exe"  /N /T "C:\\labelprint\\public\\spool\\spool.pdf"  labelprinter)
*** LINUX benutzt standardmäßigen lpr-befehl
*** Mit port=<port> lässt sich der Port festlegen, welcher von Labelprint verwendet wird
*** Mit debug=<false/ true> lässt sich steuern, ob die Label gedruckt werden, oder nur das Ausgabe-PDF im Unterordner  public/spool geschrieben wird
** Im Stammverzeichnis von Labelprint npm install ausführen, um evtl. fehlende Module zu installieren.
** Labelprint mit dem Kommando npm app.js starten (Unter Windows in der CMD mit: node app.js)
* Labelprint in der KORONA.pos konfigurieren
** im Cloud Backend einen neuen externen Systemaufruf erstellen:
*** System-URL: http://<host>:<port>/printReceipt (für den Sofortdruck)
*** Display-URL: http://<host>:<port>/printSelected (Auswahl bevor man druckt)
** Systemaufruf auf Taste oder andere Auslöser legen
* ggf. Labelpflichtige Artikel markieren
** Labelprint reagiert beim Auswahl-Modus nur auf Artikel, welche mit dem Schlagwort "label" versehen sind
** Der Sofortdruck-Modus benötigst keine tags

==Bedienung==
===Wie drucke ich?===
* An der Kasse, wie gewohnt den Beleg bebuchen und den gewünschten Auslöser für Labelprint betätigen.
* Je nach Auslöser (sofort drucken oder Druck mit Auswahl) druckt es die gewünschten Label 
** Instant-Print bietet KEIN UI und druckt die Label der einzelnen Posten sofort, sofern die Artikel der Posten über das Schlagwort "Label" verfügen
** Print bietet ein UI um bestimmte Posten auszuwählen und zu drucken. Dabei spielt das "Label"-Schlagwort keine Rolle. Es werden alle ausgewählten Posten gedruckt

* bei dem externen Systemaufruf den Haken bei POST (Request Data) setzen, da ansonsten der DEMO Modus mit entspr. Vorselektion ausgeführt wird

====Die verschiedenen Funktionen====
Im Abschnitt [[#REST API|REST API]] werden diverse Aufrufe beschrieben, von denen einige an der Kasse konfiguriert werden und andere von Labelprint selbst oder aus debug zwecken benutzt werden.
Hier eine Beschreibung der Featureaufrufe als externe Systemaufrufe für die Kasse: 
=====printSelected=====
* Zeigt eine Seite mit einer Auswahl aller auf dem Beleg befindlichen Posten. 
* Der Kassierer kann diese ab- und wieder anwählen. Es werden nur ausgewählte Posten gedruckt. 
* Die Quantity des Posten bestimmt, wie oft ein Etikett gedruckt werden soll.
* Hierbei handelt es sich um eine Display-Url.
=====printReceipt=====
* Druckt alle auf dem Beleg befindlichen Posten ungefragt sofort. 
* Druckt nur mit dem Schlagwort "label" versehene Artikel am Posten.
* Die Quantity des Posten bestimmt weiterhin die Anzahl der Etiketten.
* Hierbei handelt es sich im eine System-Url.

=====printAcumulated=====
* Druckt alle auf dem Beleg befindlichen Posten ungefragt sofort. 
* Druckt nur mit dem Schlagwort "label" versehene Artikel am Posten.
* <big>Die Quantity des Posten lässt den Preis auf dem Etikett akkumulieren.</big>
* Hierbei handelt es sich im eine System-Url.

===Pflege des Mindesthaltbarkeitsdatums===
Soll ein MHD auf den Label der Posten erscheinen, so muss der Artikel im Backend mit jenem versorgt werden.
Dies geschieht, indem man dem Artikel einen Garantietext anhängt, der über eine Integer Zahl verfügt und für die Anzahl an Stunden der Haltbarkeit ab Verkauf steht.


===LOsnummer vomFass===
für die Verwendung der Losnummer auf muss die Labelprintversion min 1.3.x belaufen - da sonst unknown field ausgegeben wird

===Etikettenlayout===
Mittels der label_configuration.json, die neben der app.js liegen muss, ist es möglich individuelle Layouts zuerstellen. 
Die Konfigurations liegt dabei im JSON-Format vor.
Das Orginal liegt im Unterverzeichnis "public/configuration".

====Layoutfelder====
=====page=====
{|class="wikitable"
!tag
!zulässige werte
!Beschreibung
|----
|layout
|"portrait", "landscape"
|Hoch- oder Querformat (portrait wird hier immer empfohlen!)
|----
|width
|
|Breite
|----
|height
|
|Höhe
|----
|textFields
|JSONArray
|Hält eine beliebige Anzahl an textfeldern, die auf dem label positioniert werden sollen
|----
|codes
|JSONArray
|Hält eine beliebige Anzahl an codes, die auf dem label positioniert werden sollen
|----
|}
=====textField=====
{|class="wikitable"
!tag
!zulässige werte
!Beschreibung
|----
|type
|siehe Liste [[#textField-Types]]
|
|----
|text
|STRING
|Nur für type === "text" relevant
|----
|font
|STRING (Times_New_Roman.ttf)
|Filename der ensprechenden .ttf im public/fonts ordner. Neue Fonts müssen manuell in den Ordner gelegt werden.
|----
|fontsize
|INT
|Größe der Schrift
|----
|x
|INT
|x-Koordinate (millimeter)
|----
|y
|INT
|y-Koordinate (millimeter)
|----
|rotate
|DOUBLE (xx.xx)
|lässt das feld um seine obere linke ecke rotieren
|----
|}

=====code=====
{|class="wikitable"
!tag
!zulässige werte
!Beschreibung
|----
|bcid
|siehe Liste [[#Codes]]
|Gibt die Art des Codes an. (Barcode, QR-Code, Aztec, ...)
|----
|scale
|INT >0
|Bestimmt die Bitrate des Bildes
|----
|includetext
|"true", "false"
|Bestimmt ob der Code den recocnition-code der Kasse abdrucken soll
|----
|textalign
|"center"
|includetext align
|----
|textsize
|INT
|includetext size
|----
|}

====textField-Types====
{|class="wikitable"
!type
!Beschreibung
|----
|text
|Freitext
|----
|productDescription
|Name des Artikels
|----
|productNumber
|Nummer des Artikels
|----
|productPrice
|Preis des Artikels
|----
|expirationDate
|Ablaufdatum des Artikels
|----
|decsriptionText
|Artikeltext Beschreibung
|----
|receiptText
|Artikeltext
|----
|orderText
|Artikeltext
|----
|recipeText
|Artikeltext
|----
|ingredientsText
|Artikeltext
|----
|allergenText
|Artikeltext
|----
|additiveText
|Artikeltext
|----
|nutritionText
|Artikeltext
|----
|careText
|Artikeltext
|----
|instructionText
|Artikeltext
|----
|certificateText
|Artikeltext
|----
|warrantyText
|Artikeltext
|----
|}

====Codes====
bwip-js implements the same barcode types as BWIPP. A comprehensive list includes:

AusPost 4 State Customer Code
Aztec Code
BC412
Channel Code
Codablock F
Code 11
Code 128
Code 16K
Code 25
Code 39
Code 39 Extended
Code 49
Code 93
Code 93 Extended
Code One
Data Matrix
Deutsche Post Identcode
Deutsche Post Leitcode
EAN-13
EAN-13 Composite
EAN-2 (2 digit addon)
EAN-5 (5 digit addon)
EAN-8
EAN-8 Composite
Flattermarken
GS1 Composite 2D Component
GS1 Data Matrix
GS1 DataBar Expanded
GS1 DataBar Expanded Composite
GS1 DataBar Expanded Stacked
GS1 DataBar Expanded Stacked Composite
GS1 DataBar Limited
GS1 DataBar Limited Composite
GS1 DataBar Omnidirectional
GS1 DataBar Omnidirectional Composite
GS1 DataBar Stacked
GS1 DataBar Stacked Composite
GS1 DataBar Stacked Omnidirectional
GS1 DataBar Stacked Omnidirectional Composite
GS1 DataBar Truncated
GS1 DataBar Truncated Composite
GS1-128
GS1-128 Composite
GS1-14
HIBC Codablock F
HIBC Code 128
HIBC Code 39
HIBC Data Matrix
HIBC MicroPDF417
HIBC PDF417
HIBC QR Code
ISBN
ISMN
ISSN
ITF-14
Interleaved 2 of 5 (ITF)
Italian PharmaCode
Japan Post 4 State Customer Code
MSI Modified Plessey
MaxiCode
MicroPDF417
Miscellaneous symbols
PDF417
Pharmaceutical Binary Code
Pharmazentralnummer (PZN)
Plessey UK
PosiCode
QR Code
Rationalized Codabar
Raw DAFT succession for custom 4 state symbologies
Raw bar space succession for custom symbologies
Royal Dutch TPG Post KIX 4-State Barcode
Royal Mail 4 State Customer Code (RM4SCC)
SSCC-18
Telepen
Two-track Pharmacode
UPC-A
UPC-A Composite
UPC-E
UPC-E Composite
United States Postal Service Intelligent Mail
United States Postal Service PLANET
United States Postal Service POSTNET

====Beispiel Layout====
<pre>
<script type="text/javascript">
  var json={
	"layout": "portrait",
	"width": 50,
	"height": 25,
	"textFields": 
	[
		{
			"type": "text",
			"text": "Kaufladen 1337",
			"fontsize": 3,
			"x": 12,
			"y": 5,
			"width": 50,
			"height": 3,
			"rotate": 0
		},

		{
			"type": "productDescription",
			"fontsize": 4,
			"x": 12,
			"y": 8,
			"width": 50,
			"height": 8,
			"rotate": 0
		},

		{
			"type": "productPrice",
			"fontsize": 3,
			"x": 12,
			"y": 13,
			"width": 50,
			"height": 4,
			"rotate": 0
		},

		{
			"type": "expirationDate",
			"dateFormat": "[Haltbar bis:] DD.MM.YYYY  HH:mm",
			"fontsize": 2,
			"x": 12,
			"y": 18,
			"width": 30,
			"height": 4,
			"rotate": 0
		}
	],

	"codes": 
	[
		{
			"bcid": "code128",
			"scale": 5,
			"includetext": false,
			"textalign": "center",
			"textsize": 13,
			"x": 10,
			"y": 5,
			"width": 18,
			"height": 5,
			"rotate": 90
		},

		{
			"bcid": "qrcode",
			"scale": 10,
			"includetext": false,
			"textalign": "center",
			"textsize": 13,
			"x": 38,
			"y": 18,
			"width": 5,
			"height": 5,
			"rotate": 0
		}
	]
};
</script></pre>
==REST API==
Der Service beschreibt einen REST-Service, der mittels JSON und HTML kommuniziert.
===POST:http://<host>:<port>/printSelected=== 
===GET:http://<host>:<port>/printSelected=== 
===POST:http://<host>:<port>/printReceipt===

===POST:http://<host>:<port>/printArticles===
===POST:http://<host>:<port>/printAcumulated===

==Verweise==
* http://pdfkit.org/
** Framework zur generierung des PDF
* https://www.npmjs.com/package/bwip
** Framwork zur erstellung der grafischen Codes
